﻿local GarrisonDone = ...

if (not GarrisonDone_Varsm) then GarrisonDone_Varsm = {} end

if (not GarrisonDoneFrame) then GarrisonDoneFrame = GarrisonDoneFrame end
    
local DEBUG = false;

local playerName = UnitName("player");

C_Timer.After(20, function() GarrisonDone_minimap(self, mgdLDB) end)
                        
            -- LDB LAUNCHER and LDB MINIMAP ICON --
local GarrisonDone_Varsc = _G.GarrisonDone_Varsc
local GarrisonDone_Varsf = _G.GarrisonDone_Varsf
local GarrisonDone_Varsm = _G.GarrisonDone_Varsm
local GarrisonDone_Vars = _G.GarrisonDone_Vars
local mgdLDB = LibStub:GetLibrary("LibDataBroker-1.1")
local icon = LibStub("LibDBIcon-1.0")

        
            -- LDB --    
local mgdLDB = LibStub:GetLibrary("LibDataBroker-1.1"):NewDataObject("GarrisonDone", {
            type = "data source",
	        text = "My Garrison",
            label = "My Garrison",
            tocname = "GarrisonDone",
            icon = "Interface\\AddOns\\GarrisonDone\\images\\MGDL.tga",
            OnClick = function(self, button, ...)
            if (button == "LeftButton") then
		    if GarrisonDoneFrame:IsShown() then
                GarrisonDoneFrame:Hide()
                GarrisonDoneOptEditFrame:Hide();
                GarrisonDoneEditFrame:Hide();
                GarrisonDoneBuildFrame:Hide();
                GarrisonDoneBuildScrollFrame:Hide();
                GarrisonDoneAltsFrame:Hide();
                GarrisonDoneAltsScrollFrame:Hide();
                GarrisonDoneOptEditFrame:Hide();
                GarrisonDoneFollowersFrame:Hide();
                GarrisonDoneFollowersScrollFrame:Hide();
            else
                PanelTemplates_SetTab(GarrisonDoneFrame, 1);
                GarrisonDoneFrame:Show()
                GarrisonDoneEditFrame:Show();
                MGD_FollowersButton:Show();
                GarrisonDoneBuildFrame:Hide();
                GarrisonDoneBuildScrollFrame:Hide();
                GarrisonDoneAltsFrame:Hide();
                GarrisonDoneAltsScrollFrame:Hide();
                GarrisonDoneOptEditFrame:Hide();
                GarrisonDoneFollowersFrame:Hide();
                GarrisonDoneFollowersScrollFrame:Hide();
                end
       	    elseif (button == "RightButton") then
                if GarrisonDoneOptEditFrame:IsShown() then
                PanelTemplates_SetTab(GarrisonDoneFrame, 1);
			    GarrisonDoneEditFrame:Show();
                GarrisonDoneBuildFrame:Hide();
                GarrisonDoneBuildScrollFrame:Hide();
                GarrisonDoneAltsFrame:Hide();
                GarrisonDoneAltsScrollFrame:Hide();
                GarrisonDoneOptEditFrame:Hide();
                GarrisonDoneFollowersFrame:Hide();
                GarrisonDoneFollowersScrollFrame:Hide();
            else
                GarrisonDoneFrame:Show()
                GarrisonDoneOptEditFrame:Show();
                GarrisonDoneEditFrame:Hide();
                MGD_FollowersButton:Hide();
                GarrisonDoneBuildFrame:Hide();
                GarrisonDoneBuildScrollFrame:Hide();
                GarrisonDoneAltsFrame:Hide();
                GarrisonDoneAltsScrollFrame:Hide();
                GarrisonDone_OptionsOnShow(self);
                GarrisonDoneFollowersFrame:Hide();
                GarrisonDoneFollowersScrollFrame:Hide();
            end
         end
    end
		    
    })
     
  
        -- Tablet --
        
        local mgdLDB_tablet	= AceLibrary("Tablet-2.0")
        local mgdldb_frame	= CreateFrame("frame")
        local GarrisonDone_Varsc = _G.GarrisonDone_Varsc
        
        -- Update Tablet Data --        
function mgdLDB:Update()   
            local GarrisonDone_Varsc = _G.GarrisonDone_Varsc
            local GarrisonDone_Varsm = _G.GarrisonDone_Varsm
            local GarrisonDone_Varsf = _G.GarrisonDone_Varsf
            local GarrisonDone_Vars = _G.GarrisonDone_Vars
		    mgdLDB_tablet:SetHint("|cffffd200Left|r |cffffff00Click for My Garrison Panel. |cffffff00Right Click for Interface. |cffffff00Shift Right Click to Move MGD Button.")
            mgdLDB_tablet:SetTitle("|cffffffff"..playerName.."'s Garrison|r")
            
            -- START GARRISON DATA --
            
            cat = mgdLDB_tablet:AddCategory('id', 'garrison', 'columns', 1, 'text', "")
                cat:AddLine('text', "---------------------------------------------------- ")
       
            -- Assign Local Variables straight from Blizz frame --
            local missionsldb = C_Garrison.GetInProgressMissions()
    
            -- Max Followers --
            local maxFollowersldb = C_Garrison.GetFollowerSoftCap(LE_FOLLOWER_TYPE_GARRISON_6_0);
            local maxShipsldb = C_Garrison.GetFollowerSoftCap(LE_FOLLOWER_TYPE_SHIPYARD_6_2);
    
            -- Active Followers --
            local numActiveFollowersldb = C_Garrison.GetNumActiveFollowers(LE_FOLLOWER_TYPE_GARRISON_6_0);
            local numActiveShipsldb = C_Garrison.GetNumActiveFollowers(LE_FOLLOWER_TYPE_SHIPYARD_6_2);
    
            -- Missions Available --
            local AvailableItemsldb = C_Garrison.GetAvailableMissions(LE_FOLLOWER_TYPE_GARRISON_6_0);
            local shipMissionsldb = C_Garrison.GetAvailableMissions(LE_FOLLOWER_TYPE_SHIPYARD_6_2);
    
            -- Missions Complete --
            local completeMissionsldb = C_Garrison.GetCompleteMissions(LE_FOLLOWER_TYPE_GARRISON_6_0);
            local shipCompleteldb = C_Garrison.GetCompleteMissions(LE_FOLLOWER_TYPE_SHIPYARD_6_2);
            
            -- Ship Missions in Progress --
            local ldbsitems = C_Garrison.GetInProgressMissions(LE_FOLLOWER_TYPE_SHIPYARD_6_2);
            local ldbshipmis = 0;
            for i = 1, #ldbsitems do
            if (ldbsitems[i].followerTypeID == 2) then
                        ldbshipmis = ldbshipmis + 1
                end
            end        
            local ldbmips = ldbshipmis - #shipCompleteldb
            
            -- Missions in Progress --
            local ldbitems = C_Garrison.GetLandingPageItems(LE_FOLLOWER_TYPE_GARRISON_6_0);
            local ldbmip = (#ldbitems - ldbshipmis) - #completeMissionsldb;
            
            -- Find all our Followers/Ships and Set Status --
            local ldbfollowers = C_Garrison.GetFollowers(LE_FOLLOWER_TYPE_GARRISON_6_0);
            local ldbships = C_Garrison.GetFollowers(LE_FOLLOWER_TYPE_SHIPYARD_6_2);
    
                -- Followers working --
            local ldbwork = 0;
            for i = 1, #ldbfollowers do
	        if ( ldbfollowers[i].status == GARRISON_FOLLOWER_WORKING) then
		        ldbwork = ldbwork + 1;
                end
            end
                -- Followers on Missions --
            local ldbgfm = 0;
            for i = 1, #ldbfollowers do
	            if ( ldbfollowers[i].status == GARRISON_FOLLOWER_ON_MISSION) then
		            ldbgfm = ldbgfm + 1;
                end
            end
                -- Ships on Missions --
            local ldbatSea = 0;
            for i = 1, #ldbships do
	            if ( ldbships[i].status == GARRISON_FOLLOWER_ON_MISSION) then
		            ldbatSea = ldbatSea + 1;
                end
            end
            
            local ldbfBusy = ldbgfm + ldbwork;
            local ldbavailable = numActiveFollowersldb - ldbfBusy;
            local ldbharbour = numActiveShipsldb - ldbatSea;
            
                -- Garrison Resources --
            local _, currentAmount, _, _, _, _, _ = GetCurrencyInfo(824);
            local _, currAmount, _, _, _, _, _ = GetCurrencyInfo(1101);
    
                -- Mining Nodes --
            local ore = 0;
            if GarrisonDone_Varsc.hasMine == true then
		        if GarrisonDone_Varsc.miningLeft > 0 then
		        ore = format("%s", GarrisonDone_Varsc.miningLeft)
                tonumber(ore)
		        end
            end
            local ores = 0;
            if GarrisonDone_Varsc.hasMine == true then
		        if GarrisonDone_Varsc.maxMining > 0 then
		        ores = format("%s", GarrisonDone_Varsc.maxMining)
                tonumber(ores)
		        end
	        end 
                -- Herb Nodes --
            local herb = 0;
            if GarrisonDone_Varsc.hasGarden == true then
    	        if GarrisonDone_Varsc.herbingLeft > 0 then
		        herb = format("%s", GarrisonDone_Varsc.herbingLeft)
                tonumber(herb)
		        end
	        end 
            local herbs = 0;
            if GarrisonDone_Varsc.hasGarden == true then
		        if GarrisonDone_Varsc.maxHerbing > 0 then
		        herbs = format("%s", GarrisonDone_Varsc.maxHerbing)
                tonumber(herbs)
                
                            end
                        end
		                        
                
            
                -- PRINT GARRISON DATA --
          
                if GarrisonDone_Varsc.ldbgar ~= true then
                    -- Missions in Progress --
                    if ldbmip ~= 0 then
		        cat:AddLine('text', "      Missions in Progress|cff007fff = |cffffffff"..ldbmip.."");
                    elseif ldbmip == 0 then
                cat:AddLine('text', "      |cffffffffMissions in Progress|cff007fff = |r|cffff0000"..ldbmip.."");
                    end
                    -- Complete Missions --
		        cat:AddLine('text', "      Missions Complete|cff007fff = |cff00aa00"..#completeMissionsldb.."");
                    -- Missions Available --
		        cat:AddLine('text', "      Missions Available|cff007fff = |r"..#AvailableItemsldb.."");
                cat:AddLine('text', "   -----------------------------------------")  
                    -- Followers --
                cat:AddLine('text', "         |cffFF8000Total |cff62fb71Followers|cff007fff = |r"..numActiveFollowersldb.."|cff007fff/|cffFF8000"..maxFollowersldb.."");
                    -- Followers Available --
                    if ldbavailable > 0 then
		        cat:AddLine('text', "         |cff62fb71Followers|r Available|cff007fff = |r"..ldbavailable.."");
                    elseif ldbavailable == 0 then
                cat:AddLine('text', "         |cff62fb71Followers|r Available|cff007fff = |r|cff00aa00"..ldbavailable.."");
                    elseif ldbavailable > 25 then
                cat:AddLine('text', "         |cff62fb71Followers|r Available|cff007fff = |r|cffff0000"..ldbavailable.."");       
                    end
                    -- Followers Working
		        cat:AddLine('text', "         |cff62fb71Followers|r Working|cff007fff = |r"..ldbwork.."");
                    -- Followers on Mission
                    if ldbgfm ~= 0 then
	            cat:AddLine('text', "         |cff62fb71Followers|r on Mission|cff007fff = |cffFF8000"..ldbgfm.."");
                    elseif ldbgfm == 0 then
                cat:AddLine('text', "         |cff62fb71Followers|r on Mission|cff007fff = |cffff0000"..ldbgfm.."");
                    end
                cat:AddLine('text', "   -----------------------------------------")
                    -- Ships Missions in Progress --
                    if ldbmips ~= 0 then
                cat:AddLine('text', "      Ships in Progress|cff007fff = |r|cffffffff"..ldbmips.."");
                    elseif ldbmips == 0 then
                cat:AddLine('text', "      |cffffffffShips in Progress|cff007fff = |r|cffff0000"..ldbmips.."");
                    end
                    -- Ships Missions Complete --
                cat:AddLine('text', "      Ships Complete|cff007fff = |r"..#shipCompleteldb.."");
                    -- Ships Mission Available --
                cat:AddLine('text', "      Ship Missions Avail|cff007fff =|r "..#shipMissionsldb..""); 
                cat:AddLine('text', "   -----------------------------------------")
                    -- Number of Ships --
                cat:AddLine('text', "         |cffFF8000Total |cff53aafcShips|cff007fff = |r|cff00aa00"..numActiveShipsldb.."/|cffFF8000"..maxShipsldb.."")
                    -- Ships out on Mission --
                cat:AddLine('text', "         |cff53aafcShips at Sea|cff007fff = |r"..ldbatSea.."")
                    -- Ships in Shipyard --
                cat:AddLine('text', "         |cff53aafcShips in Dock|cff007fff = |r|cff00aa00"..ldbharbour.."")
                cat:AddLine('text', "   -----------------------------------------")
                
                    -- Garrison Resources and Oil --
		        cat:AddLine('text', "      Resources|cff007fff = |rG - "..currentAmount.." - |cffFF8000O - "..currAmount.."")
                cat:AddLine('text', "   ----------------------------------------------   ")  
                
                        -- Mining Nodes --
                        if ore ~= 0 and herb ~= 0 then
		            cat:AddLine('text', "      Mine:|cff007fff = |cffff0000"..ore.."|cff007fff/|cff00aa00"..ores.."|r  Herbs: |cff007fff = |cffff0000"..herb.."|cff007fff/|cff00aa00"..herbs.."");
                        elseif ore == 0 and herb ~= 0 then
                    cat:AddLine('text', "      Mine: |cff007fff = |r"..ore.."|cff007fff/|cff00aa00"..ores.."|r Herbs: |cff007fff = |cffff0000"..herb.."|cff007fff/|cff00aa00"..herbs.."");
                        end
                        -- Herb Nodes --
                        if herb == 0 and ore ~= 0 then
		            cat:AddLine('text', "      Mine:|cff007fff = |cffff0000"..ore.."|cff007fff/|cff00aa00"..ores.."|r Herbs: |cff007fff = |cffff0000"..herb.."|cff007fff/|cff00aa00"..herbs.."");
                        elseif herb == 0 and ore == 0 then
                    cat:AddLine('text', "      Mine: |cff007fff = |r"..ore.."|cff007fff/|cff00aa00"..ores.."|r Herbs:|cff007fff = |r"..herb.."|cff007fff/|cff00aa00"..herbs.."");  
                        end
                    cat:AddLine('text', "   ----------------------------------------------   ")  
                        
                    
            end
            -- End Garrison Data --
            
            
            
            -- START BUILDING SHIPMENTS DATA and FOLLOWERS ASSIGNED DATA --
            
            cat = mgdLDB_tablet:AddCategory('id', 'garrison', 'columns', 1, 'text', "")
            if GarrisonDone_Varsc.ldbbui ~= true then
            cat:AddLine('text', "          ALL BUILDINGS and SHIPMENTS")
            cat:AddLine('text', "---------------------------------------------------- ")
            cat:AddLine('text', "")
            cat:AddLine('text', "|cffFF8000Name|r     Follower|cff62fb71  Building    |cff1eff00Ready|r/|cfffeef02Work|r/|cffe6cc80Total")
            cat:AddLine('text', "---------------------------------------------------- ")
            
            local l = 0
			    local d = 0
                if GarrisonDone_Varsb then
					for realm, v1 in pairs(GarrisonDone_Varsb) do
						for character, v2 in pairs(v1) do
							for index, data in pairs(v2) do
								l = l + 1
                                    local bname = data.bname
									local buildingID = data.buildingID
									
                                    local color = "|cffE6CC80"
                                        -- Set Class Colors --
                                    if data.class == "Death Knight" then color = "|cffC41F3B"
                                    elseif data.class == "Druid" then color = "|cffFF7D0A"
                                    elseif data.class == "Hunter" then color = "|cffABD473"
                                    elseif data.class == "Mage" then color = "|cff69CCF0"
                                    elseif data.class == "Monk" then color = "|cff00FF96"
                                    elseif data.class == "Paladin" then color = "|cffF58CBA"
                                    elseif data.class == "Priest" then color = "|cffFFFFFF"
                                    elseif data.class == "Rogue" then color = "|cffFFF569"
                                    elseif data.class == "Shaman" then color = "|cff0070DE"
                                    elseif data.class == "Warlock" then color = "|cff9482C9"
                                    elseif data.class == "Warrior" then color = "|cffC79C6E"
                                    end
                                            -- Is there a Follower Assigned --
                                    local fname = nil
                                    if data.fname ~= nil then fname = data.fname 
                                    else fname = "|cffff0000Gone Fishing" end
                                        -- Shorten the Mines for Alliance --
                                    if data.idName == "Lunarfall Excavation" then data.idName = "Excavation" end
                                        -- Shorten the Shipyard for Alliance --
                                    if data.idName == "Lunarfall Shipyard" then data.idName = "Shipyard" end
                                        -- Shorten the Gnomish Gearworks for Alliance --
                                    if data.idName == "Gnomish Gearworks" then data.idName = "Gearworks" end
                                        -- Shorten the Goblin Workshop for Horde --
                                    if data.idName == "Goblin Workshop" then data.idName = "Workshop" end
                                        -- Give Ready and Total a number in case there are none in progress --
                                    if data.ready == nil then data.ready = 0 end
                                    if data.total == nil then data.total = 0 end
                                    local inprog = (data.total - data.ready) -- Count down In progress --
                                        -- Is followers Assigned, Y/N --
                                    if data.fname == nil then data.fname = "|cffff0000N" 
                                    elseif data.fname ~= "|cffff0000N" then data.fname = "Y" end
                                    
                                        -- Set Labels --
                                    if data.total > 0 then
									cat:AddLine('text', (string.format(color..character.."-"..realm:sub(1,5)..":|r "..fname:sub(1,11).." |cffE6CC80"..data.idName:sub(1,20).."|r:  |cff1eff00"..data.ready.."|cffffffff -  |cfffeef02"..inprog.."|cffffffff - |cffe6cc80"..data.capacity.. "")))
                                	cat:AddLine('text', "---------------------------------------------------- ") 
                                    else
                                    if data.total == 0 then
									cat:AddLine('text', (string.format(color..character.."-"..realm:sub(1,5)..":|r "..fname:sub(1,11).." |cffE6CC80"..data.idName:sub(1,20).."|r:  |cff1eff00"..data.ready.."|cffffffff -  |cffff0000"..inprog.."|cffffffff - |cffe6cc80"..data.capacity..   "")))
                                	cat:AddLine('text', "---------------------------------------------------- ") 
                                    end
                                end				
					        end 
					    end
				    end 
                end
            end
            
            
            
            -- End Followers Assigned Data -- -- End Building Shipments Data --
            
            -- START MISSION DATA -- 
            cat = mgdLDB_tablet:AddCategory('id', 'garrison', 'columns', 1, 'text', "")
            if GarrisonDone_Varsc.ldbmiss ~= true then
            cat:AddLine('text', "                      ALL MISSIONS")
            cat:AddLine('text', "---------------------------------------------------- ")
            cat:AddLine('text', "")
            cat:AddLine('text', "     |cffFF8000Name               Mission           Time|r")
            cat:AddLine('text', "---------------------------------------------------- ")
            
                    -- Gather Mission Data --
            GarrisonDoneAltsFrame_Update_Log = 0
		    if GarrisonDoneAltsFrame_Update_Log <= 0 then
			local i = 0
			local b = 0 
				if GarrisonDone_Vars then
					for realm, v1 in pairs(GarrisonDone_Vars) do
						for character, v2 in pairs(v1) do
							for index, data in pairs(v2) do
								i = i + 1
									local name = data.name
									local t = data.endTime - time()
								--	local bar, texture, label, altMGDLabel, object
									local missionID = data.missionID
								--	bar = _G["text"..b]
									
                                    local color = "|cffE6CC80"
                                        -- Set Class Colors --
                                    if data.isRare ~= true then 
                                    if data.class == "Death Knight" then color = "|cffC41F3B   "
                                    elseif data.class == "Druid" then color = "|cffFF7D0A   "
                                    elseif data.class == "Hunter" then color = "|cffABD473   "
                                    elseif data.class == "Mage" then color = "|cff69CCF0   "
                                    elseif data.class == "Monk" then color = "|cff00FF96   "
                                    elseif data.class == "Paladin" then color = "|cffF58CBA   "
                                    elseif data.class == "Priest" then color = "|cffFFFFFF   "
                                    elseif data.class == "Rogue" then color = "|cffFFF569   "
                                    elseif data.class == "Shaman" then color = "|cff0070DE   "
                                    elseif data.class == "Warlock" then color = "|cff9482C9   "
                                    elseif data.class == "Warrior" then color = "|cffC79C6E   "
                                        end
                                    end
                                        -- Change to Rare Blue for Rare Missions --
									if data.isRare == true then
                                    if data.class == "Death Knight" then color = "|cff0070FFR |cffC41F3B"
                                    elseif data.class == "Druid" then color = "|cff0070FFR |cffFF7D0A"
                                    elseif data.class == "Hunter" then color = "|cff0070FFR |cffABD473"
                                    elseif data.class == "Mage" then color = "|cff0070FFR |cff69CCF0"
                                    elseif data.class == "Monk" then color = "|cff0070FFR |cff00FF96"
                                    elseif data.class == "Paladin" then color = "|cff0070FFR |cffF58CBA"
                                    elseif data.class == "Priest" then color = "|cff0070FFR |cffFFFFFF"
                                    elseif data.class == "Rogue" then color = "|cff0070FFR |cffFFF569"
                                    elseif data.class == "Shaman" then color = "|cff0070FFR |cff0070DE"
                                    elseif data.class == "Warlock" then color = "|cff0070FFR |cff9482C9"
                                    elseif data.class == "Warrior" then color = "|cff0070FFR |cffC79C6E"
                                        end
                                    end
                                        -- Add (S) for Ship Missions
                                    if data.followerTypeID == 2 then
                                    altMGDLabel:SetPoint("LEFT", 1, 0, bar)
                                    if data.class == "Death Knight" then color = "|cffFF8000S |cffC41F3B"
                                    elseif data.class == "Druid" then color = "|cffFF8000S |cffFF7D0A"
                                    elseif data.class == "Hunter" then color = "|cffFF8000S |cffABD473"
                                    elseif data.class == "Mage" then color = "|cffFF8000S |cff69CCF0"
                                    elseif data.class == "Monk" then color = "|cffFF8000S |cff00FF96"
                                    elseif data.class == "Paladin" then color = "|cffFF8000S |cffF58CBA"
                                    elseif data.class == "Priest" then color = "|cffFF8000S |cffFFFFFF"
                                    elseif data.class == "Rogue" then color = "|cffFF8000S |cffFFF569"
                                    elseif data.class == "Shaman" then color = "|cffFF8000S |cff0070DE"
                                    elseif data.class == "Warlock" then color = "|cffFF8000S |cff9482C9"
                                    elseif data.class == "Warrior" then color = "|cffFF8000S |cffC79C6E"
                                        end
                                    end
                    -- Print Mission Time --
                if t > 60 then
                    if GarrisonDone_Varsc.ldbcomp ~= true then
		            cat:AddLine('text',	(string.format("%s: %02d:%02d", color..character.."-"..realm:sub(1,4)..": |cffE6CC80"..name:sub(1,15).." |cff00FAF6", floor(t/3600), floor(mod(t,3600)/60))))
                    cat:AddLine(
                        'text', "---------------------------------------------------- "
                        )
                    end
                else
                    -- Print Mission Ready --
                if t < 60 then
		            cat:AddLine('text',	(string.format("%s: |cff1EFF0CReady", color..character.."-"..realm:sub(1,4)..": |cffE6CC80"..name:sub(1,15).."")))
                    cat:AddLine('text', "---------------------------------------------------- ")
                                end
                            end
                        end   
                    end
                end
            end
        end
    end
end

    -- Update LDB Data --
function mgdLDB_Update()
--    if mgdldb_frame:IsShown() == true then
--	GarrisonDone_UpdateData(data)
--    GarrisonDone_UpdateShipData(data)
--    GarrisonDone_UpdateFollowerData(data)
--    GarrisonDone_Update(self)
    DEFAULT_CHAT_FRAME:AddMessage("Sir We have Updated The LDB List") -- debug
--    end
end

--mgdldb_frame:SetScript("OnUpdate", mgdLDB_Update) -- update for the faux frame we created for tablet --

            -- Show, Set and Positon the Tooltip Frame used by the Tablet --
function mgdLDB.OnEnter(self)
	if not mgdLDB_tablet:IsRegistered(self) then
		mgdLDB_tablet:Register(self,
			'children', function() mgdLDB:Update() end,
			'clickable', true,
			'point', function(mgdldb_frame)
					    if mgdldb_frame:GetTop() > GetScreenHeight() / 4 then
				        local x = mgdldb_frame:GetCenter()
	                    return "TOP", "BOTTOM"
                    end
				end,
			'dontHook', true
		)
	end
	mgdLDB_tablet:Open(self)
end
                -- END TABLET --
                

                -- LDBIcon --
 
LibStub("LibDBIcon-1.0"):Register("GarrisonDone", mgdLDB, GarrisonDone_Varsm.minimap)
 
   

function GarrisonDone_minimap(self, mgdLDB)
    local GarrisonDone_Varsm = _G.GarrisonDone_Varsm
    local GarrisonDone_Varsc = _G.GarrisonDone_Varsc
	if GarrisonDone_Varsm.minimap.hide == true then
		icon:Hide("GarrisonDone")
	else 
		icon:Show("GarrisonDone")
	end
end


        -- END LDB DISPLAY --     
        